1000 REMark -------------------------------------
1010 REMark ** CLONE         (C) Norman Dunbar **
1020 REMark ** A program to copy a disc to the **
1030 REMark ** same or a different device.     **
1040 REMark -------------------------------------
1050 :
1060 REMark --------------------------------------------------------------
1070 REMark ** Amended on 18th May 1991 to :                            **
1080 REMark **                                                          **
1090 REMark ** 1. Add the function END_OF_DIRECTORY.                    **
1100 REMark ** 2. Change the FN QDOS$ to QDOS_TEXT$  to avoid confusion **
1110 REMark **    with QDOS the float variable when in BASIC.           **
1120 REMark ** 3. Changed all OOPS% to OOPS as BASIC doesn't like a SEL **
1130 REMark **    on an integer parameter.                              **
1140 REMark ** 4. Add IF COMPILED checks so that TURBO bits don't cause **
1150 REMark **    problems when in BASIC.                               **
1160 REMark ** 5. Make version 1v51 to show latest code.                **
1170 REMark ** 6. Checked for 0 memory required (null length files)     **
1180 REMark ** 7. BUG - If a file exists then POINTER was not being set **
1190 REMark **    to point to the next file in memory, thus all files   **
1200 REMark **    saved after an 'existing' file were corrupted.        **
1210 REMark --------------------------------------------------------------
1220 REMark ** Amended on 28th May 1991 to :                            **
1230 REMark **                                                          **
1240 REMark ** 1. Allow the option to sort or not.                      **
1250 REMark ** 2. Make version 1v52 to show latest code.                **
1260 REMark --------------------------------------------------------------
1270 REMark ** Amended on 29th May 1991 to :                            **
1280 REMark **                                                          **
1290 REMark ** 1. Fix the bug in GET_MEMORY when >1 loads were done.    **
1300 REMark ** 2. Make version 1v53 to show latest code.                **
1310 REMark --------------------------------------------------------------
1320 REMark ** Amended on 5th June 1991 to :                            **
1330 REMark **                                                          **
1340 REMark ** 1. Fix the bug where 0 files are loaded on last load.    **
1350 REMark ** 2. Make version 1v54 to show latest code.                **
1360 REMark --------------------------------------------------------------
1370 :
1380 DATA_AREA 10
1390 :
1400 IF COMPILED
1410    WHEN_ERROR 0
1420       prompt ERNUM%, 'Error at line ' & ERLIN%
1430       RETRY
1440    END_WHEN
1450 END IF 
1460 :
1470 :
1480 init
1490 REPeat outer
1500   get_drives
1510   do_format(d_dev$)
1520   how_many% = count_files%(s_dev$)
1530   IF how_many%
1540      DIM file_list$(how_many%, 36)
1550      DIM file_size(how_many%)
1560      DIM file_data(how_many%)
1570      DIM file_job%(how_many%)
1580      first% = 1
1590      read_files(s_dev$)
1600      sort
1610      REPeat loop
1620        max_files% = get_memory(how_many%, first%)
1630        IF max_files%
1640           load_files (buffer), (first%), (max_files%)
1650           save_files (buffer), (first%), (max_files%)
1660           DEALLOCATE buffer
1670           IF max_files% <> how_many%
1680              how_many% = how_many% - max_files%
1690              first% = max_files% + 1
1700              NEXT loop
1710           ELSE 
1720              EXIT loop
1730           END IF 
1740        ELSE 
1750           PRINT \\'Remaining files are too big to copy'\\
1760           BEEP 32000, 2
1770           EXIT loop
1780        END IF 
1790      END REPeat loop
1800   ELSE 
1810      PRINT 'No files to copy.'
1820   END IF 
1830   title 'Any more discs ?'
1840   REPeat yn
1850     INPUT 'Any more discs to copy Y/N ? ';yn$
1860     IF yn$ = '' THEN NEXT yn: END IF 
1870     IF yn$ INSTR 'YN' THEN EXIT yn: END IF 
1880   END REPeat yn
1890   IF yn$ == 'n' THEN EXIT outer: END IF 
1900 END REPeat outer
1910 shut_down
1920 STOP
1930 :
1940 :
1950 DEFine PROCedure init
1960   DIM yn$(1)
1970   DIM version$(4)
1980   DIM dir$(64)
1990   DIM s_dev$(5)
2000   DIM d_dev$(5)
2010   buffer = 0
2020   version$ = '1.54'
2030   s_dev$ = 'flp1_'
2040   d_dev$ = 'flp2_'
2050   IF COMPILED
2060      OPEN #1, 'con_512x256a0x0'
2070   ELSE 
2080      WINDOW 512, 256, 0, 0
2090   END IF 
2100   PAPER 7: CLS
2110   WINDOW 448, 120, 36, 68
2120   PAPER 7, 0, 3: CLS
2130   WINDOW 448, 120, 32, 64
2140   PAPER 5: INK 0: BORDER 1,0: CLS
2150   IF COMPILED
2160      OPEN #2,'con_448x22a36x38'
2170   ELSE 
2180      WINDOW #2, 448, 22, 36, 38
2190   END IF 
2200   PAPER #2, 7, 0, 3: CLS #2
2210   WINDOW #2, 448, 22, 32, 34
2220   PAPER #2, 2: INK #2, 7: BORDER #2, 1, 0: CLS #2
2230   CSIZE #2, 0,1
2240   PRINT #2, ' CLONE version ' & version$ & '  (C) Norman Dunbar'
2250 END DEFine init
2260 :
2270 :
2280 DEFine PROCedure get_drives
2290   CLS
2300   PRINT 'Please enter source device ';
2310   s_dev$ = EDIT$(s_dev$, 5)
2320   PRINT 'Please enter destination device ';
2330   d_dev$ = EDIT$(d_dev$, 5)
2340   same_disc% = (s_dev$ == d_dev$)
2350 END DEFine 
2360 :
2370 :
2380 DEFine FuNction open_directory(device$)
2390   LOCal qdos, loop
2400   :
2410   REMark ** Open a directory and return QDOS id when it works **
2420   :
2430   REPeat loop
2440     qdos = FOPEN_DIRECTORY(device$)
2450     IF qdos > 0 THEN EXIT loop: END IF 
2460     prompt qdos, 'Open directory error on ' & device$
2470   END REPeat loop
2480   RETurn qdos
2490 END DEFine open_directory
2500 :
2510 :
2520 DEFine FuNction read_directory(qdos)
2530   LOCal oops
2540   :
2550   REMark ** Read a directory entry into external DIR$(64) and will **
2560   REMark ** return 0 if ok or -10 if EOF on the directory          **
2570   :
2580   IF END_OF_DIRECTORY(#qdos)
2590      RETurn -10
2600   END IF 
2610   dir$ = FREAD_DIRECTORY$(#qdos)
2620   IF LEN(dir$) = 0
2630      :
2640      REMark ** FREAD_DIRECTORY$ return zero length string if EOF   **
2650      REMark ** or a read error occurs. As EOF has been checked for **
2660      REMark ** above, a null string must have been an error.       **
2670      :
2680      prompt 0, 'Directory read error, cannot retry'
2690      shut_down
2700   END IF 
2710   RETurn 0
2720 END DEFine read_directory
2730 :
2740 :
2750 DEFine FuNction count_files%(device$)
2760   LOCal qdos, dir$(64), files%, loop, oops, ok$(1)
2770   :
2780   REMark ** Count non null files in the directory of device$ and   **
2790   REMark ** return the count                                       **
2800   :
2810   title 'Counting files on ' & s_dev$
2820   files% = 0
2830   INPUT 'Place SOURCE disc in ' & device$ & ' & press ENTER...';ok$
2840   qdos = open_directory(device$)
2850   REPeat loop
2860     oops = read_directory(qdos)
2870     IF oops = -10
2880        :
2890        REMark ** EOF **
2900        :
2910        EXIT loop
2920     END IF 
2930     IF name_length%(dir$)
2940        files% = files% + 1
2950     END IF 
2960   END REPeat loop
2970   CLOSE_DIRECTORY(qdos)
2980   RETurn files%
2990 END DEFine count_files%
3000 :
3010 :
3020 DEFine PROCedure read_files(device$)
3030   LOCal qdos, dir$(64), oops, x
3040   :
3050   REMark ** Read filenames & data from directory into arrays       **
3060   :
3070   title 'Reading file details from ' & s_dev$
3080   x = 1
3090   qdos = open_directory(device$)
3100   REPeat loop
3110     oops = read_directory(qdos)
3120     IF oops = -10
3130        :
3140        REMark ** EOF **
3150        :
3160        EXIT loop
3170     END IF 
3180     IF name_length%(dir$)
3190        file_list$(x) = file_name$(dir$)
3200        file_size(x) = file_length(dir$)
3210        file_job%(x) = file_type%(dir$)
3220        IF file_job%(x)
3230           :
3240           REMark ** EXECable file **
3250           :
3260           file_data(x) = file_data_space(dir$)
3270        ELSE 
3280           file_data(x) = 0
3290        END IF 
3300        x = x + 1
3310     END IF 
3320   END REPeat loop
3330   CLOSE_DIRECTORY(qdos)
3340 END DEFine read_files
3350 :
3360 :
3370 DEFine FuNction name_length%(dir$)
3380   RETurn 256 * CODE(dir$(15)) + CODE(dir$(16))
3390 END DEFine name_length
3400 :
3410 :
3420 DEFine FuNction file_length(dir$)
3430   RETurn (decode(dir$(1 TO 4))) - 64
3440 END DEFine file_length
3450 :
3460 :
3470 DEFine FuNction file_data_space(dir$)
3480   RETurn decode(dir$(7 TO 10))
3490 END DEFine file_data_space
3500 :
3510 :
3520 DEFine FuNction file_type%(dir$)
3530   RETurn CODE(dir$(6))
3540 END DEFine file_type%
3550 :
3560 :
3570 DEFine FuNction file_name$(dir$)
3580   RETurn dir$(17 TO (17 + name_length%(dir$) - 1))
3590 END DEFine file_name$
3600 :
3610 :
3620 DEFine PROCedure do_format(device$)
3630   LOCal yn$(1), yn, sure, media$(10)
3640   :
3650   REMark ** Format a device after making sure of the request to do **
3660   REMark ** that, ask for the media name                           **
3670   :
3680   RETRY_HERE
3690   CLS
3700   INPUT 'Place a BLANK disc in ' & device$ & ' & press ENTER...'; yn$
3710   title 'Check format ' & device$ & ' ?'
3720   REPeat yn
3730     INPUT 'Do you want to format ' & device$ & ' Y/N ? '; yn$
3740     IF yn$ = '' THEN NEXT yn: END IF 
3750     IF yn$ INSTR 'YN' THEN EXIT yn: END IF 
3760   END REPeat yn
3770   IF yn$ == 'n' THEN CLS: RETurn : END IF 
3780   PRINT 'All data on the disc will be destroyed by the format'
3790   REPeat sure
3800     INPUT 'Are you sure you wish to proceed Y/N ? ';yn$
3810     IF yn$ = '' THEN NEXT sure: END IF 
3820     IF yn$ INSTR 'YN' THEN EXIT sure: END IF 
3830   END REPeat sure
3840   IF yn$ == 'n' THEN CLS: RETurn : END IF 
3850   title 'Format ' & device$
3860   CLS
3870   PRINT 'Enter media name ';
3880   media$ = EDIT$('', 10)
3890   PRINT 'Formatting ' & device$ & media$
3900   FORMAT device$ & media$
3910   CLS
3920 END DEFine do_format
3930 :
3940 :
3950 DEFine FuNction get_memory(how_many%, first%)
3960   LOCal max_memory, max_files%, x, addr, loop
3970   :
3980   REMark ** Attempt to allocate enough memory to hold HOW_MANY%    **
3990   REMark ** files. FIRST% is a pointer to the first file in the    **
4000   REMark ** external arrays FILE_LIST$ etc. Returns the number of  **
4010   REMark ** files that can be loaded in one go. Writes the address **
4020   REMark ** of the allocated buffer to external variable BUFFER    **
4030   :
4040   title 'Allocating memory'
4050   max_files% = how_many%
4060   max_memory = 0
4070   FOR x = first% TO (max_files% + first% - 1)
4080     max_memory = max_memory + file_size(x)
4090     IF file_size(x)/2 <> INT(file_size(x)/2)
4100        :
4110        REMark ** Avoid odd addresses like the plague !!!!  **
4120        :
4130        max_memory = max_memory + 1
4140     END IF 
4150   END FOR x
4160   REPeat loop
4170     IF max_memory = 0 THEN EXIT loop: END IF 
4180     addr = ALLOCATION(max_memory)
4190     IF addr > 0 THEN EXIT loop: END IF 
4200     max_memory = max_memory - file_size(x)
4210     IF file_size(x)/2 <> INT(file_size(x)/2)
4220        :
4230        REMark ** Adjust for odd address added above **
4240        :
4250        max_memory = max_memory - 1
4260     END IF 
4270     x = x - 1
4280     IF x = first% THEN EXIT loop: END IF 
4290   END REPeat loop
4300   IF max_memory
4310      IF x <= first%
4320         prompt -3, 'Cannot allocate memory, cannot continue'
4330         shut_down
4340      END IF 
4350   END IF 
4360   buffer = addr: REMark ** Set up buffer address **
4370   RETurn x - first% + 1: REMark ** Number of file that fit buffer  **
4380 END DEFine get_memory
4390 :
4400 :
4410 DEFine PROCedure load_files(addr, first%, number%)
4420   LOCal pointer, x, ok$(1)
4430   :
4440   REMark ** Loads NUMBER% files into the buffer at ADDR, starting  **
4450   REMark ** at FIRST% in the arrays                                **
4460   :
4470   IF number% < 1 THEN RETurn : END IF 
4480   title 'Loading ' & number% & ' files from ' & s_dev$
4490   CLS
4500   IF same_disc%
4510      BEEP 9000, 4
4520      INPUT 'Make sure that SOURCE disc is in ' & s_dev$ & ' & press ENTER...';ok$
4530   END IF 
4540   RETRY_HERE
4550   pointer = addr
4560   FOR x = first% TO (first% + number% - 1)
4570     PRINT x; ' Loading ' & file_list$(x) & ' to address ' & pointer
4580     IF file_size(x)
4590        LBYTES s_dev$ & file_list$(x), pointer
4600     END IF 
4610     pointer = pointer + file_size(x)
4620     IF pointer/2 <> INT(pointer/2)
4630        :
4640        REMark ** I hate odd sized files !! **
4650        :
4660        pointer = pointer + 1
4670     END IF 
4680   END FOR x
4690 END DEFine load_files
4700 :
4710 :
4720 DEFine PROCedure save_files(addr, first%, number%)
4730   LOCal pointer, x, ok$(1), oops
4740   :
4750   REMark ** Saves NUMBER% files from the buffer at ADDR, starting  **
4760   REMark ** at FIRST% in the arrays                                **
4770   :
4780   IF number% < 1 THEN RETurn : END IF 
4790   title 'Saving ' & number% & ' files to ' & d_dev$
4800   CLS
4810   IF same_disc%
4820      BEEP 9000, 4
4830      INPUT 'Place COPY disc in ' & d_dev$ & ' & press ENTER...';ok$
4840   END IF 
4850   RETRY_HERE
4860   pointer = addr
4870   FOR x = first% TO (first% + number% - 1)
4880     PRINT x; ' Writing ' & file_list$(x) & ' from address ' & pointer
4890     oops = DEVICE_STATUS(2, d_dev$ & file_list$(x))
4900     IF oops > 0
4910        IF file_job%(x)
4920           SEXEC d_dev$ & file_list$(x), pointer, file_size(x), file_data(x)
4930        ELSE 
4940           SBYTES d_dev$ & file_list$(x), pointer, file_size(x)
4950        END IF 
4960     ELSE 
4970        BEEP 4000,2
4980        INPUT (file_list$(x)) & ' not written, error : ' & (qdos_text$(oops)); ok$
4990     END IF 
5000     pointer = pointer + file_size(x)
5010     IF pointer/2 <> INT(pointer/2)
5020        :
5030        REMark ** Dammed odd length files again ! **
5040        :
5050        pointer = pointer + 1
5060     END IF 
5070   END FOR x
5080 END DEFine save_files
5090 :
5100 :
5110 DEFine FuNction decode(what$)
5120   LOCal x, total
5130   :
5140   REMark ** Returns the value held in the string **
5150   :
5160   total = 0
5170   FOR x = 1 TO LEN(what$)
5180     total = total * 256 + CODE(what$(x))
5190   END FOR x
5200   RETurn total
5210 END DEFine decode
5220 :
5230 :
5240 DEFine PROCedure prompt(oops, text$)
5250   LOCal yn$(1), loop
5260   BEEP 19000, 40
5270   PRINT
5280   PRINT text$
5290   PRINT qdos_text$(oops)
5300   PRINT
5310   REPeat loop
5320     INPUT 'Do you wish to attempt to continue Y/N ? '; yn$
5330     IF yn$ = '' THEN NEXT loop: END IF 
5340     IF yn$ INSTR 'YN' THEN EXIT loop: END IF 
5350   END REPeat loop
5360   IF yn$ == 'y' THEN RETurn : END IF 
5370   shut_down
5380 END DEFine prompt
5390 :
5400 :
5410 DEFine PROCedure shut_down
5420   LOCal ok$(1)
5430   title 'Close down, bye bye'
5440   INPUT 'Press ENTER to kill clone....';ok$
5450   IF COMPILED
5460      CLOSE #2
5470      CLOSE #1
5480   END IF 
5490   STOP
5500 END DEFine shut_down
5510 :
5520 :
5530 DEFine FuNction qdos_text$(oops)
5540   SELect ON oops
5550     = 0:  RETurn ''
5560     = -1: RETurn 'Not complete'
5570     = -2: RETurn 'Invalid job'
5580     = -3: RETurn 'Out of memory'
5590     = -4: RETurn 'Out of range'
5600     = -5: RETurn 'Buffer overflow'
5610     = -6: RETurn 'Channel not open'
5620     = -7: RETurn 'Not found'
5630     = -8: RETurn 'File already exists'
5640     = -9: RETurn 'In use'
5650     = -10: RETurn 'End of file'
5660     = -11: RETurn 'Drive full'
5670     = -12: RETurn 'Bad device name'
5680     = -13: RETurn 'Transmit error'
5690     = -14: RETurn 'Format failed'
5700     = -15: RETurn 'Bad parameter'
5710     = -16: RETurn 'File error'
5720     = -17: RETurn 'Error in expression'
5730     = -18: RETurn 'Arithmetic overflow'
5740     = -19: RETurn 'Not implemented'
5750     = -20: RETurn 'Read only'
5760     = -21: RETurn 'Bad line'
5770     = REMAINDER : RETurn 'Error code out of range'
5780   END SELect 
5790 END DEFine qdos_text$
5800 :
5810 :
5820 DEFine PROCedure title(text$)
5830   CLS #2
5840   PRINT #2, ' CLONE ' & version$ & ' -  '  & text$
5850 END DEFine title
5860 :
5870 :
5880 DEFine PROCedure sort
5890  LOCal a, b, loop, temp_list$(36), temp_job%, temp_size, temp_data
5900  LOCal yn, ok$(1)
5910  title 'Check if sort required'
5920  REPeat yn
5930    INPUT 'Do you wish to sort Y/N ';ok$
5940    IF ok$ == 'y' THEN EXIT yn: END IF 
5950    IF ok$ == 'n' THEN RETurn : END IF 
5960  END REPeat yn
5970  title 'Sorting, please wait...'
5980  FOR a = 1 TO how_many% - 1
5990    b = a
6000    temp_list$ = file_list$(b + 1)
6010    temp_job% = file_job%(b + 1)
6020    temp_size = file_size(b + 1)
6030    temp_data = file_data(b + 1)
6040    REPeat loop
6050      IF temp_size < file_size(b) AND b > 0
6060         file_size(b + 1) = file_size(b)
6070         file_data(b + 1) = file_data(b)
6080         file_job%(b + 1) = file_job%(b)
6090         file_list$(b + 1) = file_list$(b)
6100         b = b - 1
6110      ELSE 
6120         EXIT loop
6130      END IF 
6140    END REPeat loop
6150    file_size(b + 1) = temp_size
6160    file_data(b + 1) = temp_data
6170    file_job%(b + 1) = temp_job%
6180    file_list$(b + 1) = temp_list$
6190  END FOR a
6200 END DEFine sort
